SystemOrganization addCategory: #'TpFinalSquash-Core'!
SystemOrganization addCategory: #'TpFinalSquash-TestCases'!

Object subclass: #ClubTp
	instanceVariableNames: 'nombre jugadores partidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!ClubTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 21:39'!
conNombre:unNombre
	^ (self new) nombre: unNombre ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 22:58'!
clubAgregarNuevoJugador: unNombre conRanking:unNumero  fecha: unaFecha
	"carga en la coleccion de jugadores de esta clase el nuevo jugador, desde aqui se envia el mensaje al objeto jugador"
	
	jugadores add: (JugadorTp nuevoJugadorNombre: unNombre  ranking: unNumero fecha: unaFecha)! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 01:30'!
clubAsignarRanking: unNumero nombre: unNombre fecha:unaFecha
	|jugador|
	"asigna un ranking al jugador en una fecha, se valida que el jugador exista"
	jugador  := jugadores detect: [:each | each name = unNombre].
	
	jugador jugadorAsignarRanking: unNumero  fecha: unaFecha esAsignado: true
	
! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:33'!
clubBuscarJugadorNombre: unNombre
	|jugador|
	"busca un jugador por su nombre en la coleccion local de jugadores y retorna el objeto"
	jugador := jugadores detect: [:each | (each name ) = unNombre].
		(jugador ~= nil)
						ifTrue: [^ jugador ]! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:30'!
clubBuscarRanking: unNombre fecha: unaFecha
	| jugador rankingSalida|
	
	"pruebas, 1era buscar en la coleccion de esta clase 'club' al jugador, luego pedirle a el jugador sus ranking y filtrar por la fecha
	2da buscar al jugador en la coleccion local luego a un metodo de ese jugador pasarle la fecha para que el busque el ranking y lo retorne, tengo la duda si hacer asi o intentar llegar hasta la clase raking y que ella lo retorne, aun no lo se"
	
	jugador := jugadores detect: [:each | each name = unNombre ].
	"1er"
	" jugador misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ]."
	
	"2da"
	   "se usa cuando el metodo retorna directamente el valor del ranking"
	   " ^ rankingSalida := jugador buscarRankingfecha: unaFecha . "
	
		"se utiliza cuando el metodo retorna el objeto completo del ranking"
		^ rankingSalida := (jugador jugadorBuscarRankingfecha: unaFecha ) ranking ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:40'!
clubEditarRankingNombre: unNombre Fecha: unaFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
	|jugador|
	"asigna un ranking al jugador en una fecha, se valida que el jugador exista"
	jugador  := self clubBuscarJugadorNombre: unNombre.
	
	(jugador ~= nil)
			ifTrue: [(jugador jugadorEditarRankingFecha: unaFecha  ranking: nuevoRanking  nuevaFecha: nuevaFecha )]
	! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/17/2013 00:54'!
clubEliminarPartidoJugador1: j1 jugador2: j2 fecha: unaFecha
| jugadorLocal1 g1 jugadorLocal2 g2 aux1 aux2 partidoLocal|
"Elimina en la coleccion de partidos de clase club el partido, desde aqui se envia el mensaje a la clase partido
donde se implementa el mensaje que elimina el partido, tambien se le envia mensaje a cada jugador el partido en el que acaba de participar asi lo elimina de su historico de partidos, con jugadorLocal1 name mando el nombre y con jugadorLocal1 mando el objeto"

	jugadorLocal1 := jugadores detect: [:each | each name = j1 ].
	jugadorLocal2 := jugadores detect: [:each | each name = j2 ].

	partidos do: [:partido | (partido fecha = unaFecha) ifTrue: [ partidoLocal:= partido.partidos remove: partido ] ].

	
	aux1:= ((jugadorLocal1 jugadorBuscarRankingAnteriorfecha: unaFecha ) ranking ) . aux2:= ((jugadorLocal2 jugadorBuscarRankingAnteriorfecha: unaFecha) ranking).
	jugadorLocal1 jugadorEliminarPartido: partidoLocal rankingActualJ1: aux1 rankingActualJ2: aux2 . "el primer parametro debe ser el objeto partido a eliminar"
"	jugadorLocal2 jugadorEliminarPartido: partidoLocal rankingActualJ1: aux1 rankingActualJ2: aux2 ." "inviero aux1 por aux2"! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:47'!
clubEliminarRankingPorNombre: unNombre fecha: unaFecha
	| jugador rankingSalida|
	
	""
	
	jugador := jugadores detect: [:each | each name = unNombre ].
	jugador jugadorEliminarRankingfecha: unaFecha .! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:37'!
clubJugadoresCercanosNombre: unNombre valor: unValor
	|jugador salida|
	"devuelve todos los jugadores cuyo ranking se encuentra por encima o
	por debajo del ranking del jugador en cuestion no mas del valor ingresado
	podemos retornar el ranking actual de jugador each misRankings last ranking O el nombre del jugador each1 nombre
	La coleccion que se esta retornando no esta ordenada por lo que no se tiene un patron para retornar los objetos "

	"aqui buscamos al jugador con un metodo, hay otros metodos donde esto se hace sin llamar esta funcion, estandarizar esto!!!!!!"
	jugador  := self clubBuscarJugadorNombre: unNombre.
	salida := OrderedCollection new.

			^ (jugador jugadorRankingSimilaresPorValor: unValor jugador: jugadores)! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:43'!
clubJugadoresDentroRangoInferior: valorInferior superior: valorSuperior
| coleccionJugadores |
coleccionJugadores := OrderedCollection new.
"Recorre la coleccion de jugadores y a cada jugador le va preguntando si su ranking actual esta dentro del rango especificado"


" jugadores do: [:each | ((each dentroRangoRankingInferior: valorInferior superior: valorSuperior) ~= nil) ifTrue:[coleccionJugadores add: each ]  ]. 
^ coleccionJugadores "
	"ambas funcionan"
 ^ (self clubOrdenarJugadoresPorRanking: (jugadores reject: [:each | (each jugadorDentroRangoRankingInferior: valorInferior superior: valorSuperior) = nil ])).

 



! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 14:57'!
clubNuevoPartidoJugador1: j1 jugador2: j2 fecha: unaFecha resultado: unVector
| jugadorLocal1 g1 jugadorLocal2 g2 aux1 aux2|
"carga en la coleccion de partidos de clase club el nuevo partido, desde aqui se envia el mensaje a la clase partido
donde se implementa el mensaje que crea el partido, tambien se le envia mensaje a cada jugador el partido en el que acaba de participar asi lo almacena en su historico de partidos, con jugadorLocal1 name mando el nombre y con jugadorLocal1 mando el objeto
se debe validar que la fecha del partido a agregar no sea anterior a la fecha ingreso de cada jugador y tampoco sea igual a ninguna fecha cargada en el historico de los jugadores"

	jugadorLocal1 := jugadores detect: [:each | each name = j1 ].
	jugadorLocal2 := jugadores detect: [:each | each name = j2 ].

	((jugadorLocal1 jugadorValidarFecha: unaFecha ) & (jugadorLocal2 jugadorValidarFecha: unaFecha  ))
	ifTrue: [
	g1 := unVector at: 1.
	g2 := unVector at: 2.
	partidos add: (PartidoTp partidoNuevoPartidoJugador1: jugadorLocal1 jugador2: jugadorLocal2 fecha: unaFecha  gamesJugador1: g1 gamesJugador: g2 ).
	
	" aux1:= (jugadorLocal1 misRankings last ranking ) . aux2:= (jugadorLocal2 misRankings last ranking )."
	aux1:= ((jugadorLocal1 jugadorBuscarRankingfecha: unaFecha) ranking ) . aux2:= ((jugadorLocal2 jugadorBuscarRankingfecha: unaFecha) ranking).
	jugadorLocal1 jugadorAgregarPartido: (partidos last) rankingActualJ1: aux1 rankingActualJ2: aux2 .
	jugadorLocal2 jugadorAgregarPartido: (partidos last) rankingActualJ1: aux1 rankingActualJ2: aux2 .
		]! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:14'!
clubOrdenarJugadoresPorRanking: coleccionJugadores
"Compara ranking actual del jugador self con el ranking actual de los demas jugadores de la colecion y los ordena de manera desc"
| i j tamanio r1 temp|

		i := 1.tamanio := coleccionJugadores size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((coleccionJugadores at: i ) misRankings last ranking  > (coleccionJugadores at: j) misRankings last ranking )
										ifFalse: [temp := coleccionJugadores  at: i.
													coleccionJugadores at: i put: (coleccionJugadores at: j).
													coleccionJugadores at: j put: temp.											
													].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ coleccionJugadores! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 22:48'!
initialize 
	jugadores := OrderedCollection new.
	partidos := OrderedCollection new! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/9/2013 23:46'!
jugador: unaPosicion
	"Creo q este metodo nadie lo llama"
	^ jugadores at: unaPosicion ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 20:37'!
nombre
	^ nombre ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/7/2013 20:37'!
nombre:unNombre
	nombre := unNombre ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/11/2013 17:35'!
ordenarJugadoresPorRanking: coleccionJugadores
"Compara ranking actual del jugador self con el ranking actual de los demas jugadores de la colecion y los ordena de manera desc"
| i j tamanio r1 temp|

		i := 1.tamanio := coleccionJugadores size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((coleccionJugadores at: i ) misRankings last ranking  > (coleccionJugadores at: j) misRankings last ranking )
										ifFalse: [temp := coleccionJugadores  at: i.
													coleccionJugadores at: i put: (coleccionJugadores at: j).
													coleccionJugadores at: j put: temp.											
													].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ coleccionJugadores! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 22:45'!
partido: unaPosicion
	^ partidos at: unaPosicion ! !

!ClubTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 14:32'!
partidos 
	^ partidos ! !

Object subclass: #PartidoTp
	instanceVariableNames: 'jugador1 jugador2 fecha gamesJugador1 gamesJugador2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!PartidoTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 21:18'!
nuevoPartidoPlayer1: jugador1 player2: jugador2 fecha: unaFecha  gamesJugador1: g1 gamesJugador: g2

	^ (self new) jugador1: jugador1 ;jugador2: jugador2 ; fecha: unaFecha; gamesJugador1: g1; gamesJugador2: g2
! !

!PartidoTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 21:30'!
partidoNuevoPartidoJugador1: jugador1 jugador2: jugador2 fecha: unaFecha  gamesJugador1: g1 gamesJugador: g2

	^ (self new) jugador1: jugador1 ;jugador2: jugador2 ; fecha: unaFecha; gamesJugador1: g1; gamesJugador2: g2
! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:51'!
fecha
	^ fecha ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:53'!
fecha: unaFecha
	fecha := unaFecha ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:57'!
gamesJugador1 
	^ gamesJugador1 ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:58'!
gamesJugador1: unNumero
	gamesJugador1 := unNumero ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:57'!
gamesJugador2 
	^ gamesJugador2 ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:58'!
gamesJugador2: unNumero
	gamesJugador2 := unNumero ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:53'!
jugador1 
	^ jugador1 ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:55'!
jugador1: unJugador
	jugador1 := unJugador ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:55'!
jugador2
	^ jugador2 ! !

!PartidoTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 20:56'!
jugador2: unJugador
	jugador2 := unJugador ! !

Object subclass: #PersonaTp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

PersonaTp subclass: #JugadorTp
	instanceVariableNames: 'name rankingInicial fechaIngreso misPartidos misRankings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!JugadorTp class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:10'!
newJugadorNombre: unNombre ranking: unNumero fecha: unaFecha
	^ self new nombre: unNombre; rankinInicial: unNumero ; fechaIngreso: unaFecha 
	! !

!JugadorTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:49'!
nuevoJugadorNombre: unNombre ranking: unNumero fecha: unaFecha
	"1era se crea solo el jugador
	2da se envia un mensje a un metodo que inplementa la creacion del jugador y inicializa la coleccion de 	ranking"
		
	"^ (self new) nombre: unNombre; rankinInicial: unNumero ; fechaIngreso: unaFecha " 
	
	^ (self new) jugadorNuevoJugador: unNombre  fecha: unaFecha  ranking: unNumero 
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/17/2013 00:57'!
actualizarRankingPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2
"rna"
		| rna |
	rna :=	self jugadorObtenerRankingGamesA: (unPartido gamesJugador1) gamesB:(unPartido gamesJugador2)  rActualJa: raj1  rActualJb: raj2.
			
		! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 00:23'!
actualizarrankingDesFecha: unaFecha rankingAnt: rankingAnt
	| rankingAntOponente partidoActual raj1Anterior raj2Anterior|
	misRankings do: [:ranking | ((ranking fecha > unaFecha) & (ranking esAsignado = false))
		 ifTrue: [ 
					partidoActual := (self buscarPartidoFecha: ranking fecha).
					(self name = (partidoActual jugador1 name ))
			
				ifTrue: [
				raj1Anterior:=  (self jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking."raj1 ."
				raj2Anterior:= ((partidoActual jugador2  jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking).
				ranking ranking: (self jugadorObtenerRankingGamesA: (partidoActual gamesJugador1) gamesB:(partidoActual gamesJugador2)  rActualJa: raj1Anterior  rActualJb: raj2Anterior
									).	     
				partidoActual jugador2 actualizarrankingDesFecha:(partidoActual fecha)  rankingAnt: 1
		]
				ifFalse: [
				raj2Anterior:=  (self jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking."raj1 ."
				raj1Anterior:= ((partidoActual jugador1  jugadorBuscarRankingAnteriorfecha: partidoActual fecha) ranking).
			  ranking ranking:	(self jugadorObtenerRankingGamesA: (partidoActual gamesJugador2) gamesB:(partidoActual gamesJugador1)  rActualJa: raj2Anterior  rActualJb: raj1Anterior  
								).	
				partidoActual jugador1 actualizarrankingDesFecha:(partidoActual fecha)  rankingAnt: 1					
						]
			
					]
			]
! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 00:09'!
buscarPartidoFecha: unaFecha
	^ misPartidos detect: [:each | each fecha = unaFecha ]! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:07'!
fechaIngreso 
	^ fechaIngreso ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:07'!
fechaIngreso: unaFecha
	fechaIngreso := unaFecha ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:07'!
initialize 
	misPartidos := OrderedCollection new.
	misRankings := OrderedCollection new! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 01:55'!
jugadorAgregarPartido: unPartido
| rna ra ka ga  sa ea ea1 pa rnb rb kb gb sb eb eb1 eb2 pb |
	misPartidos add: unPartido.
	self ordenarColeccion: misPartidos  por: 'X'  orden: 'X'	.
		
	(self name = (unPartido jugador1 name ))
			ifTrue: [
		     ra:= self misRankings last ranking. "estoy utilizando el ultimo ranking, deberia ser el anterior a la fecha del part"
			  (ra < 1500)
							ifTrue: [ ka := 32]
							ifFalse: [ (ra > 1900) 
														ifTrue: [ka:= 16]
														ifFalse: [ka:=24]
										
								].
			  ga := unPartido gamesJugador1.	  pa := unPartido gamesJugador2.
			  (ga > pa ) ifTrue: [sa := 1] ifFalse: [sa := 0].
			  rb := unPartido jugador2 misRankings last ranking.
		     ]
	ifFalse: [
		     ra:= self misRankings last ranking. "estoy utilizando el ultimo ranking, deberia ser el anterior a la fecha del part"
			  (ra < 1500)
							ifTrue: [ ka := 32]
							ifFalse: [ (ra > 1900) 
														ifTrue: [ka:= 16]
														ifFalse: [ka:=24]
										
								].
			  ga := unPartido gamesJugador2.	  pa := unPartido gamesJugador1.
			  (ga > pa ) ifTrue: [sa := 1] ifFalse: [sa := 0].
			  rb := unPartido jugador1 misRankings last ranking.		
		].
	
	ea1 := (( rb - ra) / 400). 	ea := 1 / ( 1 + (10 raisedTo: ea1)).	
	rna := (ra + (ka * (sa - ea)) + ga - pa) roundTo: 0.000001 .
	self jugadorAsignarRanking: rna fecha: (unPartido fecha)  esAsignado: false
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 16:15'!
jugadorAgregarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
| rna |
	misPartidos add: unPartido.
	self ordenarColeccion: misPartidos  por: 'X'  orden: 'X'	.
		
	(self name = (unPartido jugador1 name ))
			ifTrue: [
				rna :=	self jugadorObtenerRankingGamesA: (unPartido gamesJugador1) gamesB:(unPartido gamesJugador2)  rActualJa: raj1  rActualJb: raj2 
		     ]
	ifFalse: [
			  rna :=	self jugadorObtenerRankingGamesA: (unPartido gamesJugador2) gamesB:(unPartido gamesJugador1)  rActualJa: raj2  rActualJb: raj1 
		].
	
	self jugadorAsignarRanking: rna fecha: (unPartido fecha)  esAsignado: false
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 01:04'!
jugadorAsignarRanking: unNumero fecha: unaFecha esAsignado: unaBandera
| rankingSalida |
	"agregar ranking al historico"

	" misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ]. "
	misRankings add: (RankingTp nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera ).
	
	self ordenarRankingPor: 'fecha' orden: 'asc'.
	
	self actualizarrankingDesFecha: unaFecha  rankingAnt: 1! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 18:12'!
jugadorBuscarRankingAnteriorfecha: unaFecha
| rankingSalida coleccionAux |
	"Recorro los rankings del jugador y retorno el de la fecha anterior"

	coleccionAux := OrderedCollection new.

				misRankings do: [:each | ( each fecha < unaFecha )
												ifTrue: [coleccionAux add: each]
									  ]	.
			
	self ordenarColeccion: coleccionAux  por: 'X'  orden: 'X'.
	^ coleccionAux last.
	
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:06'!
jugadorBuscarRankingfecha: unaFecha
| rankingSalida coleccionAux |
	"Recorro los rankings del jugador y cuando una fecha coincida con el parametro retorno al jugador
	si no esta la fecha exacta busco la mas cerca hacia abajo"

	"prueba usar detect"
	
	"aqui voy a retornar directamente el ranking del objeto ranking que pertenece al jugador en determinada fecha"
	" misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ rankingSalida := ranking ranking ] ].
	^ rankingSalida "
	
	"aqui voy a retornar el objeto ranking pertenece al jugador en determinada fecha"
	" ^ misRankings detect: [:ranking | (ranking fecha) = unaFecha ] "
	coleccionAux := OrderedCollection new.
	rankingSalida := misRankings detect: [:ranking | (ranking fecha) = unaFecha ] ifNone:[nil] .
	(rankingSalida  = nil)
	 ifTrue:  [ 
				misRankings do: [:each | ( each fecha < unaFecha )
												ifTrue: [coleccionAux add: each]
									  ]
				
				 ]
	
	 ifFalse: [^ rankingSalida ] .
			
	self ordenarColeccion: coleccionAux  por: 'X'  orden: 'X'.
	^ coleccionAux last.
	
	
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:43'!
jugadorDentroRangoRankingInferior: valorInferior superior: valorSuperior
| rankingActual |
"Retorna self si el ranking actual del jugador esta dentro del rango especificado"

rankingActual := self misRankings last ranking.
 (((rankingActual) >= valorInferior) & ((rankingActual) <= valorSuperior ))
	ifTrue: [^ self ]
	ifFalse: [^ nil] ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:40'!
jugadorEditarRankingFecha: unaFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
| ranking |	
	"Busca en la coleccion de ranking del jugador un ranking filtrado por fecha luego actualiza la fecha y el ranking"
	
	ranking := self jugadorBuscarRankingfecha: unaFecha.
	
	(ranking ~= nil)
						ifTrue: [ranking fecha: nuevaFecha.ranking ranking: nuevoRanking.
									self ordenarRankingPor: 'fecha' orden: 'asc'
								 ]! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 00:28'!
jugadorEliminarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
| partidoLocal rankingLocal rna partidosDespues rankingsAct aux2 raj1Anterior  raj2Anterior partidoActual|
	rankingsAct := OrderedCollection new.partidosDespues := OrderedCollection new.
	misPartidos do: [:partido | (partido fecha = unPartido fecha) ifTrue: [ partidoLocal := partido.misPartidos remove: partido ] ].
	self ordenarColeccion: misPartidos  por: 'X'  orden: 'X'	." no deberia ser necesario"
		
	misRankings do: [:ranking | (ranking fecha = unPartido fecha) ifTrue: [ rankingLocal := ranking.misRankings remove: ranking ] ].	
	self ordenarColeccion: misRankings por: 'X'  orden: 'X'	." no deberia ser necesario"	
	
	
	" misPartidos do: [:partido | (partido fecha > unPartido fecha) ifTrue: [ partidosDespues add: partido ] ]. "
	
	self actualizarrankingDesFecha: (unPartido fecha)  rankingAnt: raj1
	
	
		
	
! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:47'!
jugadorEliminarRankingfecha: unaFecha
| rankingSalida |
	"Recorro los rankings del jugador y cuando una fecha conincida con el parametro a buscar retorno el ranking
	Se esta planteando ordenar los ranking del jugador despues de hacer la eliminacion pero poer ahora se piensa que no va a ser necesario"

	"prueba usar detect"
	misRankings do: [:ranking | (ranking fecha = unaFecha) ifTrue: [ misRankings remove: ranking ] ].! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 14:44'!
jugadorIngresoPartidoValidoFecha: unaFecha
! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 23:22'!
jugadorMisPartidos
	^ misPartidos ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:48'!
jugadorNuevoJugador: unNombre fecha: unaFecha ranking: unNumero
	"Aqui se pretende crear un jugador y a la vez cargar en la coleccion de ranking su ranking inicial"
	
	self name: unNombre. self fechaIngreso: unaFecha . self rankingInicial: unNumero.
	
	misRankings add: ( RankingTp nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: true) .
	! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 16:13'!
jugadorObtenerRankingGamesA: ga gamesB: pa rActualJa: aRanking rActualJb: bRanking 
| rna ra ka gaa  sa ea ea1 paa rb |
"Retorna el valor del nuevo ranking aplicando la formula, esta formula se aplica a los apontes de un partido esto dependiendo del orden de los parametros al momento de enviar el mensaje"
		     ra:= aRanking. "self misRankings last ranking .estoy utilizando el ultimo ranking, deberia ser el anterior a la fecha del part"
			  (ra < 1500)
							ifTrue: [ ka := 32]
							ifFalse: [ (ra > 1900) 
														ifTrue: [ka:= 16]
														ifFalse: [ka:=24]										
								].
			  " ga := unPartido gamesJugador1.	  pa := unPartido gamesJugador2."
			  (ga > pa ) ifTrue: [sa := 1] ifFalse: [sa := 0].
			  rb :=  bRanking . "unPartido jugador2 misRankings last ranking"
			
			ea1 := (( rb - ra) / 400). 	ea := (1 / ( 1 + (10 raisedTo: ea1))) roundTo: 0.000001.	
			rna := (ra + (ka * (sa - ea)) + ga - pa) roundTo: 0.000001 .
			^ rna! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:23'!
jugadorRankingSimilaresPorValor: unValor jugador: jugadores
	|rankingJugador rangoSuperior rangoInferior salida|
	"devuelve todos los jugadores cuyo ranking se encuentra por encima o
	por debajo del ranking del jugador en cuestion no mas del valor ingresado.
	podemos retornar el ranking actual de jugador each misRankings last ranking O el nombre del jugador each1 nombre
	La coleccion que se esta retornando no esta ordenada por lo que no se tiene un patron para retornar los objetos "

	rankingJugador := self misRankings last.

		(rankingJugador ~= nil)
			ifTrue: [	"	^ rankingJugador ranking"
						rangoInferior:= (rankingJugador ranking  - unValor ).
					 	rangoSuperior := (rankingJugador ranking  + unValor).		
						salida := OrderedCollection new.

						(jugadores select: [:each | ((each misRankings last ranking  >= rangoInferior) & (each misRankings  last ranking   <= rangoSuperior) ) ]) do: [:each1 | ( each1 name  ~= self name  ) ifTrue: [ salida add: each1 ] ]
												].
				
				^ salida ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 14:59'!
jugadorValidarFecha: unaFecha
"Es para validar que cuando se quiera agregar o editar un ranking por un partido o desicion de un administrador este ingreso sea valido, es decir no sea menor a la fecha ingreso y no se tenga otro partido ni ranking asignado el mismo dia y misma hora"

misPartidos detect: [:each | (each fecha = unaFecha )] ifNone:[
								((unaFecha > (self misRankings first fecha )))
								ifTrue: [
											^ true
								]
																			].
^ false! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 18:07'!
misPartidos 
	^ misPartidos ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:29'!
misRankings 
	^ misRankings ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 01:32'!
name
	^ name ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 01:36'!
name: unNombre
	name := unNombre ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 00:28'!
ordenarColeccion: unaColeccion por: unCampo orden: unOrden
"Permite tener ordenada la coleccion de ranking de cada jugador por fecha, por ahora el criterio es asc no se implementado hacer un ordenamiento dinamico segun los parametros recibidos"
| i j tamanio r1 temp|

		i := 1.tamanio := unaColeccion size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((unaColeccion at: i ) fecha > (unaColeccion at: j) fecha )
										ifTrue:  [temp := unaColeccion  at: i.
													unaColeccion at: i put: (unaColeccion at: j).
													unaColeccion at: j put: temp.
													].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ unaColeccion! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/11/2013 17:16'!
ordenarJugadorPorRanking: jugadores
"Compara ranking actual del jugador self con el ranking actual de los demas jugadores de la colecion y los ordena de manera desc"
| i j tamanio r1 temp|

		i := 1.tamanio := misRankings size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((misRankings at: i ) fecha > (misRankings at: j) fecha )
										ifTrue:  [temp := misRankings  at: i.
													misRankings at: i put: (misRankings at: j).
													misRankings at: j put: temp.
													]
										ifFalse: [].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ misRankings! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/11/2013 17:35'!
ordenarRankingPor: unCriterio orden: unOrden
"Permite tener ordenada la coleccion de ranking de cada jugador por fecha, por ahora el criterio es asc no se implementado hacer un ordenamiento dinamico segun los parametros recibidos"
| i j tamanio r1 temp|

		i := 1.tamanio := misRankings size.
		[i < tamanio] whileTrue: [
		j := i+1.
		[j <= tamanio] whileTrue: [
			((misRankings at: i ) fecha > (misRankings at: j) fecha )
										ifTrue:  [temp := misRankings  at: i.
													misRankings at: i put: (misRankings at: j).
													misRankings at: j put: temp.
													].
			j := j + 1.
		].
		i := i + 1
		].
		
		^ misRankings! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:25'!
rankingInicial 
	^ rankingInicial ! !

!JugadorTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:25'!
rankingInicial: unNumero
	rankingInicial := unNumero ! !

Object subclass: #RankingTp
	instanceVariableNames: 'fecha ranking esAsignado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!RankingTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:35'!
nuevoRankingConFecha: unaFecha ranking: unNumero
	^ (self new) fecha: unaFecha ;ranking: unNumero ! !

!RankingTp class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 16:58'!
nuevoRankingConFecha: unaFecha ranking: unNumero esAsignado: unaBandera
	^ (self new) fecha: unaFecha ;ranking: unNumero ; esAsignado: unaBandera ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:00'!
esAsignado
	" indica si el ranking se cargo por una asignacion o como resultado de un partido"
	^ esAsignado ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 17:13'!
esAsignado: unaBandera
	esAsignado := unaBandera ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:19'!
fecha
	^ fecha! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:25'!
fecha: unafecha
	fecha := unafecha! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:24'!
initialize 
	esAsignado := false! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:19'!
ranking
	^ ranking ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:27'!
ranking: unNumero
	ranking := unNumero ! !

!RankingTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:23'!
setEsAsignado
	esAsignado := true! !

Object subclass: #SquashSystem
	instanceVariableNames: 'club'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!SquashSystem class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/8/2013 00:42'!
newWithName: unNombre
 | club  |  
	"voy a probar 
		1 si retorno desde aqui una instancia de ClubTp, practicamente llamare  a los metodos de ClubTp sin pasar por SquashSystem  
		2 si creo una instancia de SquashSytem, internamente creo el ClubTp y tendre en SquashSystem metodos que seran el puente a ClubTp  "
		
	" ^ ClubTp conNombre: unNombre ^ "
	
	^ self new nameClub: unNombre
	  
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:10'!
addMatchBetween: j1 and: j2 at: fecha withResult: resultadoGames
	"Envia mensaje al club para el ingreso de un nuevo partido"
	(club  first) clubNuevoPartidoJugador1: j1 jugador2: j2 fecha: fecha  resultado: resultadoGames ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:04'!
addPlayer: unNombre withRanking: unNumero  at: unaFecha
	"Envia mensaje al club para el ingreso de un nuevo jugador"
	(club  first) clubAgregarNuevoJugador: unNombre conRanking: unNumero fecha: unaFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:06'!
assignRanking: unNumero to: unNombre at: unaFecha
	"Envia mensaje al club para asignar un ranking a un jugador"
	(club  first) clubAsignarRanking: unNumero nombre: unNombre fecha: unaFecha! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/17/2013 00:06'!
club 	
	^ (club first )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:29'!
deleteMatchBetween: jugador1 and: jugador2 at: unaFecha

	(club  first) clubEliminarPartidoJugador1: jugador1 jugador2: jugador2  fecha: unaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:29'!
deleteRankingOf: unNombre at: unaFecha

	(club  first) clubEliminarRankingPorNombre: unNombre  fecha: unaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 23:01'!
editRankingOf: unNombre at: unaFecha withNewValue: nuevoRanking andNewDate: nuevaFecha

	(club  first) clubEditarRankingNombre: unNombre Fecha: unaFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:30'!
initialize 

	club := OrderedCollection new
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:30'!
nameClub

	^ (club first) nombre ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:31'!
nameClub: unNombre
	" Se crea el club "
	
	club add: (ClubTp conNombre: unNombre )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/8/2013 15:13'!
newWithNameee: unNombre
	"Agrega a la coleccion club un nuevo club el cual se crea apartir del envio de un nombre para dicho club"
	club add: (ClubTp conNombre: unNombre )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:37'!
playersNear: unNombre by: unValor

	^ (club  first) clubJugadoresCercanosNombre: unNombre  valor: unValor! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/12/2013 11:32'!
playersRankedBetween: valorInferior and: valorSuperior

	^ (club  first) clubJugadoresDentroRangoInferior: valorInferior  superior: valorSuperior 
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:32'!
rankingOf: unNombre at: unaFecha

	^ (club  first) clubBuscarRanking: unNombre  fecha: unaFecha ! !

TestCase subclass: #TestCaseSquashTp
	instanceVariableNames: 'squashSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-TestCases'!

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 22:52'!
setUp 
	squashSystem := SquashSystem newWithName: 'La Plata Squash Club'.
	
	squashSystem addPlayer: 'Ralph' withRanking: 1400 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Gail' withRanking: 2000 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Henry' withRanking: 1600 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Mark' withRanking: 1000 at: '2013-06-01' asDateAndTime.	
	squashSystem addPlayer: 'George' withRanking: 800 at: '2013-06-05' asDateAndTime.
	
	squashSystem addMatchBetween: 'Ralph' and: 'Gail' at: '2013-06-03' asDateAndTime withResult: #(3 2).
	squashSystem addMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime withResult: #(3 0).
	squashSystem addMatchBetween: 'Gail' and: 'Henry' at: '2013-06-05' asDateAndTime withResult: #(1 3).
	squashSystem addMatchBetween: 'Henry' and: 'George' at: '2013-06-07' asDateAndTime withResult: #(3 1).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 23:02'!
test01
	
	self assert: ((squashSystem rankingOf: 'Henry' at: '2013-06-06' asDateAndTime) closeTo: 1627.311424).
	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1629.514771).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-06' asDateAndTime) closeTo: 800).	
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7288709).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-06' asDateAndTime) closeTo: 1967.106627).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.106627).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 00:30'!
test02

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1625.829881).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7231018).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1983.490455).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.07565).
! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/18/2013 01:04'!
test03

" 	squashSystem assignRanking: 1600 to: 'Ralph' at: '2013-06-04' asDateAndTime.
	
	self assert: ((squashSystem rankingOf: 'Ralph' at: '2013-06-04' asDateAndTime) closeTo: 1600)."
	
	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
 	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1616.219393).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7074759).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1600).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1586).
	

! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/10/2013 01:03'!
test04

 
   squashSystem assignRanking: 1600 to: 'Ralph' at: '2013-06-04' asDateAndTime.
   squashSystem deleteRankingOf: 'Ralph' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Ralph' at:'2013-06-01' asDateAndTime) closeTo: 1400).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/10/2013 16:53'!
test05

 squashSystem editRankingOf: 'Ralph' at: '2013-06-01' asDateAndTime withNewValue: 800 andNewDate: '2013-06-01' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Ralph' at:'2013-06-01' asDateAndTime) closeTo: 800).	! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/12/2013 22:55'!
test07

	| playersCollection |

	playersCollection := squashSystem playersRankedBetween: 800 and: 1500.
	self assert: playersCollection size equals: 2.
	self assert: ((playersCollection at:1) name = 'Ralph').
	self assert: ((playersCollection at:2) name = 'Mark').! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 01:11'!
test08

	| playersCollection |

	playersCollection := squashSystem playersNear:'Mark' by: 300.
	self assert: playersCollection size equals: 1.
	self assert: ((playersCollection at:1) name = 'George').

! !
